// file automatically generated by "../../../rheolef/nfem/gbasis/basis_symbolic_cxx.cc"
///
/// This file is part of Rheolef.
///
/// Copyright (C) 2000-2009 Pierre Saramito <Pierre.Saramito@imag.fr>
///
/// Rheolef is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.
///
/// Rheolef is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.
///
/// You should have received a copy of the GNU General Public License
/// along with Rheolef; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
///
/// =========================================================================
#ifndef _RHEOLEF_P0_H
#define _RHEOLEF_P0_H
#include "rheolef/basis.h"
#include "rheolef/tensor.h"
#include "Pk_get_local_idof_on_side.icc"
namespace rheolef {

template<class T>
class basis_P0: public basis_rep<T> {
public:
  typedef basis_rep<T>          base;
  typedef typename base::size_type size_type;
  ~basis_P0();
  basis_P0() : base("P0", basis_option()) {}
  bool have_continuous_feature() const { return false; }
  bool is_continuous() const { return false; }
  bool have_degree_parameter() const { return true; }
  std::string family_name() const { return "P"; }
  void get_local_idof_on_side (
    reference_element            hat_K,
    const side_information_type& sid,
    arma::Col<size_type>&        loc_idof) const
  {
    details::Pk_get_local_idof_on_side (hat_K, sid, degree(), loc_idof);
  }
  size_type degree() const;
  bool is_nodal() const { return true; }
  size_type size (reference_element hat_K) const;
  void eval(
    reference_element                 hat_K,
    const point_basic<T>&             hat_x,
    arma::Col<T>&                     values) const;
  void grad_eval(
    reference_element                               hat_K,
    const point_basic<T>&                           hat_x,
    std::vector<point_basic<T> >&                   values) const;
  void _initialize(reference_element hat_K) const;
  const std::vector<point_basic<T> >& hat_node(reference_element hat_K) const {
    base::_initialize_guard(hat_K);
    return base::_hat_node [hat_K.variant()]; }
};
} // namespace rheoef
#endif // _RHEOLEF_P0_H

